<?php
/*--------------------------------------------------------------------
 dependent.inc.php 2020-04-03
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2020 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 -------------------------------------------------------------------*/

$index_array = [
    'container_type',
    'container_id',
    'addon_key'
];

if(!$this->indexExists('addon_values_storage','UNIQUE',$index_array))
{
    $this->set_index('addon_values_storage','UNIQUE',$index_array,'container_type_container_id_addon_key');
}

/**
 * Add Hermes HSI Parcel Service
 */
$t_check = $this->query('SELECT * FROM `parcel_services_description` WHERE `url` LIKE "%https://www.myhermes.de/empfangen/sendungsverfolgung/suchen/sendungsinformation%"', true);
if($t_check->num_rows == 0)
{
    $query        = 'INSERT INTO `parcel_services` (`name`, `default`) VALUES ("Hermes HSI", 0)';
    $lastInsertId = $this->query($query);
    $t_success &= (boolean)$lastInsertId;
    
    $query = 'INSERT INTO `parcel_services_description` (`parcel_service_id`, `language_id`, `url`, `comment`)
				VALUES
					(' . $lastInsertId . ', 1, "https://www.myhermes.de/empfangen/sendungsverfolgung/suchen/sendungsinformation#{TRACKING_NUMBER}", "You can access the shipment tracking for your order by visiting the link above."),
					(' . $lastInsertId . ', 2, "https://www.myhermes.de/empfangen/sendungsverfolgung/suchen/sendungsinformation#{TRACKING_NUMBER}", "Die Sendungsverfolgung für Ihre Bestellung können Sie über den oben stehenden Link aufrufen.")';
    $t_success &= (boolean)$this->query($query, true);
}


$checkIfFreeContent1MalibuExists = $this->query('SELECT * FROM `content_manager_aliases` WHERE `content_alias`="Malibu-below-slider"', true);
if ($checkIfFreeContent1MalibuExists->num_rows < 1) {
    
    $nextContentGroupIdQuery  = 'SELECT MAX(`content_group`) + 1 as "next_cm_id" FROM `content_manager`';
    $nextContentGroupIdResult = $this->query($nextContentGroupIdQuery, true);
    $nextContentGroupId       = (int)$nextContentGroupIdResult->fetch_assoc()['next_cm_id'];
    $contentEn                = $this->query('SELECT `content_text`, `content_status` FROM `content_manager` WHERE `content_group` = 4321002 AND `languages_id` = 1')[0];
    $contentDe                = $this->query('SELECT `content_text`, `content_status` FROM `content_manager` WHERE `content_group` = 4321002 AND `languages_id` = 2')[0];
    
    $createContent = "INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_name`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_sitemap_entry`, `gm_robots_entry`, `gm_url_keywords`, `protected`, `content_position`, `content_type`,`contents_meta_title`,`contents_meta_description`,`contents_meta_keywords`) VALUES
       (0, 0, '', 1, 'Free Content 1 (Malibu)', 'Free Content 1 (Malibu)', '', '%s' , 0, 4, '', '', '" . $contentEn['content_status'] . "', $nextContentGroupId, 0, '', '', '0.5', 'weekly', 0, 0, '', '1', 'elements_start', 'content','','',''),
       (0, 0, '', 2, 'Freier Inhalt 1 (Malibu)', 'Freier Inhalt 1 (Malibu)', '', '%s', 0, 4, '', '', '" . $contentDe['content_status'] . "', $nextContentGroupId, 0, '', '', '0.5', 'weekly', 0, 0, '', '1', 'elements_start', 'content','','','')";
    
    $t_success &= $this->query(sprintf($createContent, $contentEn['content_text'], $contentDe['content_text']), true);
    
    $createAliasQuery = 'INSERT INTO `content_manager_aliases` (`content_group`, `content_alias`) VALUES (' . $nextContentGroupId . ', "Malibu-below-slider");';
    $t_success &= $this->query($createAliasQuery, true);
}

/** @var \DatabaseModel $this */

$displayTypeColumnExistQuery = 'SHOW COLUMNS FROM `properties` LIKE "display_type"';
$displayTypeColumnExist      = $this->query($displayTypeColumnExistQuery, true);

if ($displayTypeColumnExist->num_rows === 1) {
    
    $columnValuesThatAreNotDefaultQuery = 'SELECT DISTINCT `display_type` FROM `properties` WHERE `display_type` != "dropdown"';
    $columnValuesThatAreNotDefault      = $this->query($columnValuesThatAreNotDefaultQuery, true);
    
    //  this can only be safely removed if only default values are present
    //  otherwise we remove data on rerunning the update in a later version
    if ($columnValuesThatAreNotDefault->num_rows === 0) {
        
        $removingDisplayTypeQuery = 'ALTER TABLE `properties` DROP COLUMN `display_type`';
        $this->query($removingDisplayTypeQuery);
    }
}


/**
 * Changes the current value for pre existent variants
 * Note: Just in case of changing (updating) the layout of existing variants
 *
 * 1. We're checking if the shop, when updates, has an active HEADER 2 variant
 * 2. If the shop is using the variant we must change its values from theme and variants (settings.json)
 *
 */

/**
 * Helper function
 * Changes the values of the settings.json by the values passed by parameter $settingsArray
 *
 * @param $path
 * @param $settingsArray
 *
 * @return bool|false|int
 */
function changeSettingsValue($path, $settingsArray)
{
	$changed = false;
	
	if(file_exists($path))
	{
		$settingsJson = json_decode(file_get_contents($path), true);
		
		foreach($settingsJson as $index => &$setting)
		{
			if(array_key_exists($setting['name'], $settingsArray))
			{
				$setting = array_merge($settingsJson[$index], $settingsArray[$setting['name']]);
			}
		}
		
		unset($setting);
		
		$updatedSettingsJson = json_encode($settingsJson, JSON_PRETTY_PRINT);
		$changed             = file_put_contents($path, $updatedSettingsJson);
	}
	
	return $changed;
}

/**
 * Update Malibu only once, if shop is updated from version lower than 4.0
 */
$check = $this->query('SELECT * FROM `version_history` WHERE `version` > "4.0" AND `installation_date` < "'
                      . date('Y-m-d H:i:s', strtotime('-3 HOURS')) . '"', true);
if($check->num_rows < 1)
{
	$malibuSettingsJsonPath = dirname(__DIR__, 3) . '/themes/Malibu/settings.json';
	if(file_exists($malibuSettingsJsonPath))
	{
		$settingsJson = json_decode(file_get_contents($malibuSettingsJsonPath), true);
		$updateNeeded = false;
		
		// Checks if the header2 variant is active
		$filtered = array_filter($settingsJson, function ($element) {
			return ($element['name'] === 'header-variant' && $element['value']['id'] === 'header2');
		});
		
		if(count($filtered))
		{
			// Set the changes that we want to do
			$settingsToBeChanged = [
				// option ID            => values we want to change: type, group, value, etc
				'gx-hide-cart-col'      => ['value' => true],
				'gx-hide-secondary-col' => ['value' => false]
			];
			
			// If the file exists and the change was made we change the variant's settings.json
			if(changeSettingsValue($malibuSettingsJsonPath, $settingsToBeChanged))
			{
				$malibuHeader2SettingsJsonPath = dirname(__DIR__, 3)
				                                 . '/themes/Malibu/variants/header-variant/header2/settings.json';
				changeSettingsValue($malibuHeader2SettingsJsonPath, $settingsToBeChanged);
			}
		}
	}
}
